<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Middleware;

use App\Http\Controllers\Providers\IAM\Core\AuthManager\WorkerAuth;
use App\Http\Models\AdministratorgroupaccessModel;
use App\Http\Models\UsersModel;
use App\Http\Requests\Request;
use Closure;

class AuthMiddleware
{
    protected $pass = [
        "administrator/login",
        "administrator/recovery"
    ];

    public function handle($request, Closure $next, $guard = null)
    {

        WorkerAuth::auth()->model = new UsersModel();
        $route = \Request::instance()->route()->getPath();
        if (in_array($route, $this->pass)) {
            return $next($request);
        } else {

            if (!WorkerAuth::auth()->hasLogin()) {
                return redirect("administrator/login")->with("errMessage", "You have to be logged in");
            } else {
                $byPassUserRoles = [
                    "administrator/profile",
                    "administrator",
                    "administrator/logout",
                    "administrator/notifications",
                ];
                if (in_array($route, $byPassUserRoles)) {
                    return $next($request);
                } else {
                    $prefix = $request->route()->getPrefix();
                    $groupId = WorkerAuth::getAuth()->roleId;
                    $hasAccess = (new AdministratorgroupaccessModel())->joinRelationAccessid()
                        ->getQuery()->where("administratormenu.url", "=", $prefix)
                        ->where("administratorgroupaccess.groupid", "=", $groupId)->first();

                    if (!$hasAccess) {
                        return redirect("administrator/")->with("errMessage", "You have no access");
                    } else {
                        return $next($request);
                    }
                }
            }
        }

    }
}